title IGBY2 (Record or Playback games)
@echo off
:ListGames
cls
echo  1. 10 Yard Fight            2. Asteroids Deluxe       3. Battle Garegga 
echo  4. Bubble Bobble 2          5. D2K: Jumpman Returns   6. Donkey Kong 3
echo  7. Gekisou                  8. Intrepid               9. Ladybug
echo  A. Mr Do's Wild Ride        B. Ms Pacman              C. Mustache Boy
echo  D. Rainbow Islands          E. Shock Troopers         F. Sonson
echo  G. Space Fury               H. Star Fighter           I. Star Force
echo  J. Street Fighter II (CE)   K. Strikers 1945          L. Super Breakout
echo  M. Tetris Plus 2            N. Time Pilot 84          O. Time Scanner
echo  P. Triple Punch             R. Turbo Outrun           S. Turtles
echo  T. Tutankham                Q. Quit
echo[

:ChooseGame
set GameChoice=
set /p GameChoice="Choice:  "

if "%GameChoice%"=="1" set GameName=10yard
if "%GameChoice%"=="2" set GameName=astdelux
if "%GameChoice%"=="3" set GameName=bgaregga
if "%GameChoice%"=="4" set GameName=bublbob2
if "%GameChoice%"=="5" set GameName=dkongx
if "%GameChoice%"=="6" set GameName=dkong3
if "%GameChoice%"=="7" set GameName=gekisou
if "%GameChoice%"=="8" set GameName=intrepid
if "%GameChoice%"=="9" set GameName=ladybug
if "%GameChoice%"=="a" set GameName=dowild
if "%GameChoice%"=="A" set GameName=dowild
if "%GameChoice%"=="b" set GameName=mspacman
if "%GameChoice%"=="B" set GameName=mspacman
if "%GameChoice%"=="c" set GameName=mustache
if "%GameChoice%"=="C" set GameName=mustache
if "%GameChoice%"=="d" set GameName=rbisland
if "%GameChoice%"=="D" set GameName=rbisland
if "%GameChoice%"=="e" set GameName=shocktro
if "%GameChoice%"=="E" set GameName=shocktro
if "%GameChoice%"=="f" set GameName=sonson
if "%GameChoice%"=="F" set GameName=sonson
if "%GameChoice%"=="g" set GameName=spacfury
if "%GameChoice%"=="G" set GameName=spacfury
if "%GameChoice%"=="h" set GameName=starfigh
if "%GameChoice%"=="H" set GameName=starfigh
if "%GameChoice%"=="i" set GameName=starforc
if "%GameChoice%"=="I" set GameName=starforc
if "%GameChoice%"=="j" set GameName=sf2ceea
if "%GameChoice%"=="J" set GameName=sf2ceea
if "%GameChoice%"=="k" set GameName=s1945
if "%GameChoice%"=="K" set GameName=s1945
if "%GameChoice%"=="l" set GameName=sbrkout
if "%GameChoice%"=="L" set GameName=sbrkout
if "%GameChoice%"=="m" set GameName=tetrisp2
if "%GameChoice%"=="M" set GameName=tetrisp2
if "%GameChoice%"=="n" set GameName=tp84
if "%GameChoice%"=="N" set GameName=tp84
if "%GameChoice%"=="o" set GameName=timescan
if "%GameChoice%"=="O" set GameName=timescan
if "%GameChoice%"=="p" set GameName=triplep
if "%GameChoice%"=="P" set GameName=triplep
if "%GameChoice%"=="r" set GameName=toutrun
if "%GameChoice%"=="R" set GameName=toutrun
if "%GameChoice%"=="s" set GameName=turtles
if "%GameChoice%"=="S" set GameName=turtles
if "%GameChoice%"=="t" set GameName=tutankhm
if "%GameChoice%"=="T" set GameName=tutankhm
if "%GameChoice%"=="q" goto exit
if "%GameChoice%"=="Q" goto exit
if "%GameChoice%"=="z" goto exit
if "%GameChoice%"=="Z" goto exit

if "%GameName%"=="" goto InvalidChoice
goto RunGame

:InvalidChoice
echo "Invalid choice"
goto ChooseGame

:RunGame
cls

if "%InvalidMode%"=="" goto ListModes

echo Invalid mode: %Mode%
echo[

set InvalidMode=

:ListModes
echo  Current game = %GameName%
echo[
echo  1. Record
echo  2. Playback
echo  3. Choose a different game
echo  Q. Quit
echo[
Set /p Mode="Choice: "

if "%Mode%"=="1" goto RecordGame
if "%Mode%"=="2" goto PlaybackGame
if "%Mode%"=="3" goto ListGames
if "%Mode%"=="q" goto Exit
if "%Mode%"=="Q" goto Exit
set InvalidMode=Yes
goto RunGame

:RecordGame
rem if exist cfg\%GameName%.cfg move cfg\%GameName%.cfg cfg\%GameName%.bak
if exist hi\%GameName%.hi move hi\%GameName%.hi hi\%GameName%.bak
if exist nvram\%GameName%.nv move nvram\%GameName%.nv nvram\%GameName%.bak
if exist diff\%GameName%.dif move diff\%GameName%.dif diff\%GameName%.bak

mamearcade %GameName% -record %GameName%.inp %1 %2 %3 %4 %5 %6 %7 %8 %9 -nvram_directory NUL
goto ReinstateFiles

:PlaybackGame
rem if exist cfg\%GameName%.cfg move cfg\%GameName%.cfg cfg\%GameName%.bak
if exist hi\%GameName%.hi move hi\%GameName%.hi hi\%GameName%.bak
if exist nvram\%GameName%.nv move nvram\%GameName%.nv nvram\%GameName%.bak
if exist diff\%GameName%.dif move diff\%GameName%.dif diff\%GameName%.bak

mamearcade %GameName% -playback %GameName%.inp %1 %2 %3 %4 %5 %6 %7 %8 %9 -nvram_directory NUL

:ReinstateFiles
rem if exist cfg\%GameName%.bak move cfg\%GameName%.bak cfg\%GameName%.cfg
if exist hi\%GameName%.bak move hi\%GameName%.bak hi\%GameName%.hi
if exist nvram\%GameName%.bak move nvram\%GameName%.bak nvram\%GameName%.nv
if exist diff\%GameName%.bak move diff\%GameName%.bak diff\%GameName%.dif

goto RunGame

:exit
